/* *One approach to writing code;
data newshoes;
  set shoes;
  brka = '1';
  brkb = '2';
  brkc = '3';
  brkd = '4';
  output;
run;
*/

* Another approach to making "helper" variables;
* that will be the same for every observation;
data newshoes;
  retain brka '1' brkb '2' brkc '3' brkd '4';
  set shoes;
run;

options missing=' ';

ods html(id=ex5) file="&outpath\example5_Multiple_Summary_Rows.html";

proc report data=newshoes spanrows;
  where region in ('Asia' 'Canada') and
        product in ('Boot' 'Sandal' 'Slipper');
  title 'Ex 5a) COMPUTE Multiple Summary Lines using Helper Variable';
  column brka brkb brkc brkd region product sales returns Profit inventory PctInv 
         sales=salescnt sales=salesmn returns=retmn inventory=invmn;
  define brka / group noprint;
  define brkb / group noprint;
  define brkc / group noprint;
  define brkd / group noprint;
  define region / group;
  define product / group;
  define profit / computed f=dollar14.;
  define pctinv / computed f=percent9.2;
  define salescnt / N "Sales Count" f=comma6. noprint;
  define salesmn / mean "Avg Sales" noprint;
  define retmn / mean "Avg Returns" noprint;
  define invmn / mean "Avg Inventory" noprint;
  break after region/summarize style=Header;
  break after brka / summarize style=Header;
  break after brkb / summarize style=Header;
  break after brkc / summarize style=Header;
  break after brkd / summarize style=Header;
  rbreak after / summarize  style=Header;
  compute region;
    if upcase(_break_) = 'BRKD' then Region = 'Count of Sales';
	else if upcase(_break_) = 'BRKC' then Region = 'Avg Sales';
	else if upcase(_break_) = 'BRKB' then Region = 'Avg Returns';
	else if upcase(_break_) = 'BRKA' then Region = 'Avg Inventory ';
  endcomp;
  compute after region;
     brkline = ' ';
	 if region = 'Canada' then lgbrk = 1;
	 else lgbrk = 0;
	 line brkline $varying. lgbrk;
  endcomp;
  compute invmn;
    if upcase(_break_) = 'BRKD' then product = put(salescnt,comma6.);
	else if upcase(_break_) = 'BRKC' then product = put(salesmn,dollar14.);
	else if upcase(_break_) = 'BRKB' then product = put(retmn,dollar14.);
	else if upcase(_break_) = 'BRKA' then product = put(invmn,dollar14.);
    if upcase(_break_) in ('BRKA', 'BRKB', 'BRKC', 'BRKD') then do;
	   sales.sum=.;
	   pctinv = .;
	   profit = .;
	   returns.sum=.;
	   inventory.sum = .;
	   call define('product','style','style=Header{just=r}');
	end;
  endcomp;
  compute pctinv;
    profit = sum(sales.sum,-1*returns.sum);
    pctinv = sales.sum / inventory.sum;
  endcomp;
  compute after  / style=Header{just=l fontweight=bold fontsize=14pt};
     region = 'All Regions';
  endcomp;
run;

 

proc report data=newshoes spanrows;
  where region in ('Asia' 'Canada') and
        product in ('Boot' 'Sandal' 'Slipper');
  title 'Ex 5b) COMPUTE Multiple Summary Lines using Helper Variable';
  title2 'Showing All NOPRINT items';
  column brka brkb brkc brkd region product sales returns Profit inventory PctInv 
         sales=salescnt sales=salesmn returns=retmn inventory=invmn;
  define brka / group;
  define brkb / group;
  define brkc / group;
  define brkd / group;
  define region / group;
  define product / group;
  define profit / computed f=dollar14.;
  define pctinv / computed f=percent9.2;
  define salescnt / N "Sales Count" f=comma6.;
  define salesmn / mean "Avg Sales";
  define retmn / mean "Avg Returns";
  define invmn / mean "Avg Inventory";
  break after region/summarize style=Header;
  break after brka / summarize style=Header;
  break after brkb / summarize style=Header;
  break after brkc / summarize style=Header;
  break after brkd / summarize style=Header;
  rbreak after / summarize  style=Header;
  compute region;
    if upcase(_break_) = 'BRKD' then Region = 'Count of Sales';
	else if upcase(_break_) = 'BRKC' then Region = 'Avg Sales';
	else if upcase(_break_) = 'BRKB' then Region = 'Avg Returns';
	else if upcase(_break_) = 'BRKA' then Region = 'Avg Inventory ';
  endcomp;
  compute after region;
     brkline = ' ';
	 if region = 'Canada' then lgbrk = 1;
	 else lgbrk = 0;
	 line brkline $varying. lgbrk;
  endcomp;
  compute invmn;
    if upcase(_break_) = 'BRKD' then product = put(salescnt,comma6.);
	else if upcase(_break_) = 'BRKC' then product = put(salesmn,dollar14.);
	else if upcase(_break_) = 'BRKB' then product = put(retmn,dollar14.);
	else if upcase(_break_) = 'BRKA' then product = put(invmn,dollar14.);
    if upcase(_break_) in ('BRKA', 'BRKB', 'BRKC', 'BRKD') then do;
	   sales.sum=.;
	   pctinv = .;
	   profit = .;
	   returns.sum=.;
	   inventory.sum = .;
	   call define('product','style','style=Header{just=r}');
	end;
  endcomp;
  compute pctinv;
    profit = sum(sales.sum,-1*returns.sum);
    pctinv = sales.sum / inventory.sum;
  endcomp;
  compute after  / style=Header{just=l fontweight=bold fontsize=14pt};
     region = 'All Regions';
  endcomp;
run;

ods html(id=ex5) close;
